'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var TextCompleter = (function (_React$Component) {
  _inherits(TextCompleter, _React$Component);

  function TextCompleter(props) {
    _classCallCheck(this, TextCompleter);

    _get(Object.getPrototypeOf(TextCompleter.prototype), 'constructor', this).call(this, props);

    this.sourceValue = null;
    this.sourceValues = [];
    this.state = {
      query: null,
      value: this.props.defaultValue,
      sourceActive: 0
    };
  }

  _createClass(TextCompleter, [{
    key: 'getInputNode',
    value: function getInputNode() {
      return _reactDom2['default'].findDOMNode(this.refs.input.getInputNode ? this.refs.input.getInputNode() : this.refs.input);
    }
  }, {
    key: 'getQueryPos',
    value: function getQueryPos(value) {
      var cursorPos = this.getInputNode().selectionStart;

      // array position of the current lookup-query
      return value.substr(0, cursorPos).split(this.props.wordSeparator).length - 1;
    }
  }, {
    key: 'updateQuery',
    value: function updateQuery(value) {
      var cursorPos = this.getInputNode().selectionStart;
      var words = value.split(this.props.wordSeparator);
      var queryPos = this.getQueryPos(value);

      if (value.charAt(cursorPos - 1) != this.props.wordSeparator) {
        this.setState({
          query: words[queryPos]
        });
      } else {
        this.setState({
          query: null
        });
      }
    }
  }, {
    key: 'selectItem',
    value: function selectItem() {
      var _this = this;

      var node = this.getInputNode();
      var words = this.state.value.split(this.props.wordSeparator);
      var queryPos = this.getQueryPos(this.state.value);
      words[queryPos] = this.sourceValue;

      // if cursor is at the end >> add wordSeparator
      if (node.selectionStart == this.state.value.length) {
        words[words.length - 1] = words[words.length - 1] + this.props.wordSeparator;
      }

      this.setState({
        value: words.join(this.props.wordSeparator),
        query: null
      }, function () {
        var newPos = words.slice(0, queryPos + 1).join(_this.props.wordSeparator).length + 1;
        node.selectionStart = node.selectionEnd = newPos;

        // onChange
        node.dispatchEvent(new Event('input', { bubbles: true }));
      });

      node.focus();
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      var value = e.target.value;
      this.updateQuery(value);
      this.setState({
        value: value
      });

      if (this.props.onChange) this.props.onChange(e);
    }
  }, {
    key: 'onKeyUp',
    value: function onKeyUp(e) {
      switch (e.keyCode) {
        case 37: // left
        case 39:
          // right
          this.updateQuery(this.state.value);
          break;

        default:
          break;
      }
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      if (this.sourceValue === null) return;

      switch (e.keyCode) {
        case 38:
          // up
          this.setState({
            sourceActive: this.state.sourceActive - 1
          });
          e.preventDefault();
          break;

        case 40:
          // down
          this.setState({
            sourceActive: this.state.sourceActive + 1
          });
          e.preventDefault();
          break;

        case 9: // tab
        case 13:
          // enter
          if (this.sourceValue !== null) e.preventDefault();

          this.selectItem();
          break;

        default:
          break;
      }
    }
  }, {
    key: 'onSourceChange',
    value: function onSourceChange(childIndex, value, from) {
      if (from === 'changeActive') this.sourceValue = value;else {
        // on prend la premiere value non null
        if (childIndex === 0) {
          this.sourceValue = value;
        } else if (this.sourceValue === null) {
          this.sourceValue = value;
        }

        if (childIndex === _react2['default'].Children.count(this.props.children) - 1) {
          if (this.sourceValue === null) this.changeSourceActive(0);
        }
      }
    }
  }, {
    key: 'changeSourceActive',
    value: function changeSourceActive(sourceActive) {
      this.setState({ sourceActive: sourceActive });
    }

    // componentDidUpdate(prevProps, prevState) {
    //   if (this.state.value !== prevState.value) this.props.onChange(this.state.value);
    // }

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = _react2['default'].Children.map(this.props.children, function (child, i) {
        return _react2['default'].cloneElement(child, {
          query: _this2.state.query,
          itemActive: _this2.state.sourceActive,
          onValueChange: _this2.onSourceChange.bind(_this2, i),
          onActiveChange: _this2.changeSourceActive.bind(_this2),
          onSelect: function onSelect(e) {
            e.preventDefault();
            e.stopPropagation();
            _this2.selectItem();
          }
        });
      });

      var input = this.props.input !== null ? this.props.input : _react2['default'].createElement('textarea', null);

      return _react2['default'].createElement(
        'div',
        null,
        _react2['default'].cloneElement(input, {
          onKeyUp: this.onKeyUp.bind(this),
          onKeyDown: this.onKeyDown.bind(this),
          onChange: this.onChange.bind(this),
          value: this.state.value,
          ref: 'input'
        }),
        children
      );
    }
  }]);

  return TextCompleter;
})(_react2['default'].Component);

TextCompleter.defaultProps = {
  wordSeparator: ' ',
  onChange: function onChange(value) {},
  defaultValue: '',
  input: null
};

exports['default'] = TextCompleter;
module.exports = exports['default'];