'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var TokenSource = (function (_React$Component) {
  _inherits(TokenSource, _React$Component);

  function TokenSource(props) {
    _classCallCheck(this, TokenSource);

    _get(Object.getPrototypeOf(TokenSource.prototype), 'constructor', this).call(this, props);

    this.state = {
      items: [],
      active: 0,
      pending: false
    };
  }

  _createClass(TokenSource, [{
    key: 'setItems',
    value: function setItems(items) {
      this.setState({
        items: items.slice(0, this.props.itemNumber),
        active: 0,
        pending: false
      });
      this.props.onValueChange(items.length ? this.props.itemValue(items[0]) : null, 'query');
    }
  }, {
    key: 'getQuery',
    value: function getQuery(props) {
      return props.query.substr(props.token.length);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this = this;

      var items = [];

      if (nextProps.query != this.props.query) {
        if (nextProps.query !== null && nextProps.query.length > nextProps.token.length && nextProps.query.substr(0, nextProps.token.length) === nextProps.token) {
          if (typeof nextProps.data === 'function') {
            items = nextProps.data(this.getQuery(nextProps));
          } else {
            items = nextProps.data.filter(function (item) {
              return ~item.toLowerCase().indexOf(_this.getQuery(nextProps).toLowerCase());
            });
          }

          if (typeof items === 'function') {
            this.setState({
              pending: true
            });
            items(this.setItems.bind(this));
          } else {
            this.setItems(items);
          }
        } else {
          this.setItems([]);
        }
      } else if (nextProps.itemActive !== this.props.itemActive && this.state.items.length > 0) {
        var slicedItems = this.state.items;
        var active = nextProps.itemActive % slicedItems.length;
        if (active < 0) active = slicedItems.length + active;
        this.props.onValueChange(this.props.itemValue(slicedItems[active]), 'changeActive');

        this.setState({ active: active });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var items = this.state.items.map(function (e, i) {
        var liClass = _this2.props.stylemap.li + ' ';
        if (i === _this2.state.active) liClass += _this2.props.stylemap.active;

        return _react2['default'].createElement(
          'li',
          {
            key: _this2.props.itemKey(e),
            className: liClass,
            onMouseEnter: _this2.props.onActiveChange.bind(null, i),
            onClick: _this2.props.onSelect },
          _this2.props.children ? _react2['default'].cloneElement(_this2.props.children, {
            item: e,
            query: _this2.getQuery(_this2.props)
          }) : _this2.props.itemRender(e, _this2.getQuery(_this2.props))
        );
      });

      var ulClass = this.props.stylemap.ul + ' ';
      if (this.state.pending) ulClass += this.props.stylemap.pending;

      if (items.length > 0 || this.state.pending) {
        return _react2['default'].createElement(
          'ul',
          { className: ulClass },
          items
        );
      }

      return null;
    }
  }]);

  return TokenSource;
})(_react2['default'].Component);

var identity = function identity(x) {
  return x;
};
var noop = function noop() {};
TokenSource.defaultProps = {
  token: '@',
  itemNumber: 4,
  itemRender: identity, // (item, query)
  itemValue: identity,
  itemKey: identity,
  data: [],
  stylemap: {
    li: '',
    ul: '',
    pending: 'pending',
    active: 'active'
  },

  // added by textcompleter
  query: '',
  itemActive: 0,
  onValueChange: noop,
  onActiveChange: noop,
  onSelect: noop
};

exports['default'] = TokenSource;
module.exports = exports['default'];